//---------------------------------------------------------------------------
//
// Name:        primjerFrm.cpp
// Author:      User
// Created:     19.12.2008 17:13:44
// Description: primjerFrm class implementation
//
//---------------------------------------------------------------------------

#include "primjerFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// primjerFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(primjerFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(primjerFrm::OnClose)
	EVT_MENU(ID_MNU_ABOUT_1032, primjerFrm::Mnuabout1032Click)
	EVT_BUTTON(ID_WXBUTTONUNIFREF,primjerFrm::WxButtonUnifRefClick)
	EVT_BUTTON(ID_WXBUTTONKNOTS,primjerFrm::WxButtonKnotsClick)
	EVT_BUTTON(ID_WXBUTTONDEGREE,primjerFrm::WxButtonDegreeClick)
	EVT_BUTTON(ID_WXBUTTONCLEAR,primjerFrm::WxButtonClearClick)
	EVT_BUTTON(ID_WXBUTTONTOCKE,primjerFrm::WxButtonTockeClick)
	
	EVT_SPIN_UP(ID_WXSPINCTRLDEGREE,primjerFrm::WxSpinCtrlDegreeSpinUp)
	EVT_SPIN_DOWN(ID_WXSPINCTRLDEGREE,primjerFrm::WxSpinCtrlDegreeSpinDown)
	EVT_BUTTON(ID_WXBUTTON_BR_TOCAKA,primjerFrm::WxButton_br_tocakaClick)
	
	EVT_TEXT(ID_WXEDIT_BR_TOCAKA,primjerFrm::WxEdit_br_tocakaUpdated)
END_EVENT_TABLE()
////Event Table End

primjerFrm::primjerFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
    pGLCanvas = new MyGLCanvas(GLPanel,WxPanel1, ID_GLPANEL, wxPoint(0,0), wxSize(577,577));
}

primjerFrm::~primjerFrm()
{
}

void primjerFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxPanel1 = new wxPanel(this, ID_WXPANEL1, wxPoint(0,0), wxSize(850,648));
	WxPanel1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	GLPanel = new wxPanel(WxPanel1, ID_GLPANEL, wxPoint(218,39), wxSize(577,577));
	GLPanel->Enable(false);
	GLPanel->SetForegroundColour(*wxLIGHT_GREY);
	GLPanel->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_SCROLLBAR));
	GLPanel->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText1 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT1, wxT("Broj tocaka( <102):"), wxPoint(25,67), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxEdit_br_tocaka = new wxTextCtrl(WxPanel1, ID_WXEDIT_BR_TOCAKA, wxT(""), wxPoint(25,95), wxSize(66,19), 0, wxDefaultValidator, wxT("WxEdit_br_tocaka"));
	WxEdit_br_tocaka->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButton_br_tocaka = new wxButton(WxPanel1, ID_WXBUTTON_BR_TOCAKA, wxT("OK"), wxPoint(112,91), wxSize(35,26), 0, wxDefaultValidator, wxT("WxButton_br_tocaka"));
	WxButton_br_tocaka->Enable(false);
	WxButton_br_tocaka->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText2 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT2, wxT("Odredite tocke misem!"), wxPoint(24,138), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->Enable(false);
	WxStaticText2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	testLabel = new wxStaticText(WxPanel1, ID_TESTLABEL, wxT("0"), wxPoint(27,573), wxDefaultSize, 0, wxT("testLabel"));
	testLabel->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxSpinCtrlDegree = new wxSpinCtrl(WxPanel1, ID_WXSPINCTRLDEGREE, wxT("2"), wxPoint(21,201), wxSize(83,24),wxSP_ARROW_KEYS, 2, 100, 2);
	WxSpinCtrlDegree->Enable(false);
	WxSpinCtrlDegree->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText3 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT3, wxT("Stupanj krivulje:"), wxPoint(25,174), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->Enable(false);
	WxStaticText3->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonTocke = new wxButton(WxPanel1, ID_WXBUTTONTOCKE, wxT("OK"), wxPoint(157,135), wxSize(36,25), 0, wxDefaultValidator, wxT("WxButtonTocke"));
	WxButtonTocke->Enable(false);
	WxButtonTocke->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticText4 = new wxStaticText(WxPanel1, ID_WXSTATICTEXT4, wxT("Koordinate:"), wxPoint(23,540), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxCheckBoxRotation = new wxCheckBox(WxPanel1, ID_WXCHECKBOXROTATION, wxT("Rotacija"), wxPoint(22,475), wxSize(66,18), wxCHK_2STATE  | wxALIGN_RIGHT, wxDefaultValidator, wxT("WxCheckBoxRotation"));
	WxCheckBoxRotation->Show(false);
	WxCheckBoxRotation->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonClear = new wxButton(WxPanel1, ID_WXBUTTONCLEAR, wxT("Obrisi"), wxPoint(21,436), wxSize(75,24), 0, wxDefaultValidator, wxT("WxButtonClear"));
	WxButtonClear->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxCheckBoxZoom = new wxCheckBox(WxPanel1, ID_WXCHECKBOXZOOM, wxT("Zoom"), wxPoint(22,507), wxSize(65,16), wxCHK_2STATE  | wxALIGN_RIGHT, wxDefaultValidator, wxT("WxCheckBoxZoom"));
	WxCheckBoxZoom->Show(false);
	WxCheckBoxZoom->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxStaticTextKnots = new wxStaticText(WxPanel1, ID_WXSTATICTEXTKNOTS, wxT("Upisi cvorove odvojene zarezom:"), wxPoint(12,253), wxDefaultSize, 0, wxT("WxStaticTextKnots"));
	WxStaticTextKnots->Show(false);
	WxStaticTextKnots->Enable(false);
	WxStaticTextKnots->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonDegree = new wxButton(WxPanel1, ID_WXBUTTONDEGREE, wxT("OK"), wxPoint(125,200), wxSize(39,25), 0, wxDefaultValidator, wxT("WxButtonDegree"));
	WxButtonDegree->Enable(false);
	WxButtonDegree->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonKnots = new wxButton(WxPanel1, ID_WXBUTTONKNOTS, wxT("OK"), wxPoint(155,333), wxSize(34,26), 0, wxDefaultValidator, wxT("WxButtonKnots"));
	WxButtonKnots->Show(false);
	WxButtonKnots->Enable(false);
	WxButtonKnots->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxEditKnots = new wxTextCtrl(WxPanel1, ID_WXEDITKNOTS, wxT(""), wxPoint(9,292), wxSize(173,22), 0, wxDefaultValidator, wxT("WxEditKnots"));
	WxEditKnots->Show(false);
	WxEditKnots->Enable(false);
	WxEditKnots->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	tmpLabel = new wxStaticText(WxPanel1, ID_TMPLABEL, wxT("tmpLabel"), wxPoint(23,609), wxDefaultSize, 0, wxT("tmpLabel"));
	tmpLabel->Show(false);
	tmpLabel->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxButtonUnifRef = new wxButton(WxPanel1, ID_WXBUTTONUNIFREF, wxT("Unif. Ref."), wxPoint(15,326), wxSize(75,25), 0, wxDefaultValidator, wxT("WxButtonUnifRef"));
	WxButtonUnifRef->Enable(false);
	WxButtonUnifRef->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Segoe UI")));

	WxMenuBar1 = new wxMenuBar();
	wxMenu *ID_MNU_HELP_1031_Mnu_Obj = new wxMenu(0);
	ID_MNU_HELP_1031_Mnu_Obj->Append(ID_MNU_ABOUT_1032, wxT("About"), wxT(""), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_HELP_1031_Mnu_Obj, wxT("Help"));
	SetMenuBar(WxMenuBar1);

	WxMessageDialog1 =  new wxMessageDialog(this, wxT("Program koji omogucava crtranje B-spline krivulje stupnja 2 te uniformno profinjavanje cvorova. \n Autor: Drago Spoljaric"), wxT("O programu"), wxICON_INFORMATION);

	SetTitle(wxT("Uniform B-spline refinement"));
	SetIcon(wxNullIcon);
	SetSize(15,10,866,684);
	Center();
	
	////GUI Items Creation End
}

void primjerFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


/*
 * WxButton_br_tocakaClick
 */
void primjerFrm::WxButton_br_tocakaClick(wxCommandEvent& event)
{
    pGLCanvas->BSpline.br_tocaka = atoi(WxEdit_br_tocaka->GetValue());
	
    //int br_tocaka = atoi(WxEdit_br_tocaka->GetValue());
	//wxString stupanj;
    //stupanj.Printf("%d", br_tocaka-1);
	//testLabel->SetLabel(stupanj);
	//WxSpinCtrlDegree->SetValue(br_tocaka-1);
	//WxSpinCtrlDegree->SetMin(br_tocaka-1);
	
    WxStaticText2->Enable(true);
	GLPanel->Enable(true);
	WxEdit_br_tocaka->Enable(false);
	//WxButtonTocke->Enable(true);

}



/*
 * WxSpinCtrlDegreeSpinDown
 */
void primjerFrm::WxSpinCtrlDegreeSpinDown(wxSpinEvent& event )
{
	wxString stupanj;
    int deg = WxSpinCtrlDegree->GetValue();
    if(deg > WxSpinCtrlDegree->GetMin()){
        --deg;
        pGLCanvas->BSpline.decreaseDegree(deg);
    }
}

/*
 * WxSpinCtrlDegreeSpinUp
 */
void primjerFrm::WxSpinCtrlDegreeSpinUp(wxSpinEvent& event)
{
	wxString stupanj;
    int deg = WxSpinCtrlDegree->GetValue();
    ++deg; //moramo rucno povecati vrijednost jer GetValue() uvijek vrati za
    //jedan manje nego pise na ekrenu u WxSpinCtrl kontroli

    pGLCanvas->BSpline.elevateDegree(deg);


}

/*
 * WxButtonTockeClick
 */
void primjerFrm::WxButtonTockeClick(wxCommandEvent& event)
{
	//WxSpinCtrlDegree->Enable(true);
	WxButtonDegree->Enable(true);
	WxButton_br_tocaka->Enable(false);
	WxStaticText3->Enable(true);
}



/*
 * WxButtonClearClick
 */
void primjerFrm::WxButtonClearClick(wxCommandEvent& event)
{
    pGLCanvas->Clear();
    pGLCanvas->draw_curve = false;
    
	WxStaticText2->Enable(false);
	WxStaticText3->Enable(false);
	GLPanel->Enable(false);
	WxEdit_br_tocaka->Enable(true);
	WxButtonTocke->Enable(false);
	WxSpinCtrlDegree->Enable(false);
	WxButton_br_tocaka->Enable(true);
	WxButtonDegree->Enable(false);
	WxEditKnots->Enable(false);
	WxButtonKnots->Enable(false);
	WxStaticTextKnots->Enable(false);
	WxButtonUnifRef->Enable(false);
}

/*
 * WxButtonDegreeClick
 */
void primjerFrm::WxButtonDegreeClick(wxCommandEvent& event)
{
    pGLCanvas->BSpline.degree = WxSpinCtrlDegree->GetValue();
    pGLCanvas->BSpline.br_cvorova = pGLCanvas->BSpline.degree+1 + pGLCanvas->BSpline.br_tocaka;
    
    
    for(int i(0);i<pGLCanvas->BSpline.br_cvorova;++i){
            pGLCanvas->BSpline.knots[i] = (float)i;
    }

    pGLCanvas->draw_curve = true;
    pGLCanvas->Draw();

	/* Ovo je za eventualnu nadogradnju za samostalno defiriranje proizvoljnog
	vektora cvorova
    wxString br_cvorova;
    br_cvorova.Printf("Upisite %d cvorova \nodvojenih zarezom:", pGLCanvas->BSpline.br_cvorova);
	WxStaticTextKnots->SetLabel(br_cvorova);
    */
    
	//WxStaticTextKnots->Enable(true);
	//WxEditKnots->Enable(true);
	WxSpinCtrlDegree->Enable(false);
	WxButtonDegree->Enable(false);
	//WxButtonKnots->Enable(true);
	WxStaticText2->Enable(false);
	WxButtonTocke->Enable(false);
	WxButtonUnifRef->Enable(true);
	

}

/*
 * WxButtonKnotsClick
 */
void primjerFrm::WxButtonKnotsClick(wxCommandEvent& event)
{
	wxString wxstr_knots;
	wxstr_knots = WxEditKnots->GetValue();
	
	std::vector<wxString> vec_knots;
	
	int index = wxstr_knots.Find(",");
	while(index != wxNOT_FOUND){
        
        vec_knots.push_back(wxstr_knots.SubString(0,index-1));
        wxstr_knots = wxstr_knots.SubString(index+1,wxstr_knots.Length());
        index = wxstr_knots.Find(",");
    }
    vec_knots.push_back(wxstr_knots);
    
        for(int i(0);i<vec_knots.size();++i){
            pGLCanvas->BSpline.knots[i] = atof(vec_knots[i].c_str());
        }
        pGLCanvas->draw_curve = true;
        pGLCanvas->Draw();
}

/*
 * WxButtonUnifRefClick
 */
void primjerFrm::WxButtonUnifRefClick(wxCommandEvent& event)
{
    // Ovime cemo napraviti uniformno profinjenje krivulje

if(2*(pGLCanvas->BSpline.br_tocaka-1)+pGLCanvas->BSpline.degree+1 < 5000){
    //onda ima jos mjesta za spremanje cvorova
    float *old_knots;
    float **old_controlPoints;
    
    //prvo zapisemo "stare" cvorove "sa strane"
    old_knots = new float[pGLCanvas->BSpline.br_cvorova];
	for(int i(0);i < pGLCanvas->BSpline.br_cvorova;++i){
        old_knots[i] = pGLCanvas->BSpline.knots[i];
    }
    
    //spremamo stare tocke "sa strane"
    old_controlPoints = new float*[pGLCanvas->BSpline.br_tocaka];
    for(int i(0);i<pGLCanvas->BSpline.br_tocaka;++i) old_controlPoints[i] = new float[3];

    for(int i(0);i < pGLCanvas->BSpline.br_tocaka;++i){
        old_controlPoints[i][0] = pGLCanvas->BSpline.controlPoints[i][0];
        old_controlPoints[i][1] = pGLCanvas->BSpline.controlPoints[i][1];
        old_controlPoints[i][2] = pGLCanvas->BSpline.controlPoints[i][2];
    }
    
    
    //racunamo nove cvorove
    for(int i(0);i < 2*(pGLCanvas->BSpline.br_tocaka-1)+pGLCanvas->BSpline.degree+1;++i){
        pGLCanvas->BSpline.knots[i] = i;
    }
    pGLCanvas->BSpline.br_cvorova = 2*(pGLCanvas->BSpline.br_tocaka-1)+pGLCanvas->BSpline.degree+1;
    int br_novih_cv = 2*(pGLCanvas->BSpline.br_tocaka-1)-pGLCanvas->BSpline.br_tocaka;
    
    
    /* ovo je dio za eventualnu nadogradju za samostalno postavljanje vektora cvorova
    wxString novi_cvorovi_str;
    wxString broj;
    for(int i(0);i < pGLCanvas->BSpline.br_cvorova-1;++i){
        broj.Printf("%.0f,",pGLCanvas->BSpline.knots[i]);
        novi_cvorovi_str+=broj;
    }
    broj.Printf("%.0f",pGLCanvas->BSpline.knots[pGLCanvas->BSpline.br_cvorova-1]);
    novi_cvorovi_str+=broj;

    WxEditKnots->SetValue(novi_cvorovi_str);
    */
    
    //racunamo nove tocke kontrolnog poligona
    // broj tocaka kontrolnog poligona poveceati ce se za br_novih_cv


    for(int i(0);i < pGLCanvas->BSpline.br_tocaka-1;++i){
        pGLCanvas->BSpline.controlPoints[2*i][0] = 0.75*old_controlPoints[i][0]+0.25*old_controlPoints[i+1][0];
        pGLCanvas->BSpline.controlPoints[2*i][1] = 0.75*old_controlPoints[i][1]+0.25*old_controlPoints[i+1][1];
        pGLCanvas->BSpline.controlPoints[2*i][2] = 0.75*old_controlPoints[i][2]+0.25*old_controlPoints[i+1][2];
        
        pGLCanvas->BSpline.controlPoints[2*i+1][0] = 0.25*old_controlPoints[i][0]+0.75*old_controlPoints[i+1][0];
        pGLCanvas->BSpline.controlPoints[2*i+1][1] = 0.25*old_controlPoints[i][1]+0.75*old_controlPoints[i+1][1];
        pGLCanvas->BSpline.controlPoints[2*i+1][2] = 0.25*old_controlPoints[i][2]+0.75*old_controlPoints[i+1][2];    
    }

    delete [] old_knots;

    for(int i(0);i<pGLCanvas->BSpline.br_tocaka;++i) delete [] old_controlPoints[i];
    delete [] old_controlPoints;
    
    pGLCanvas->BSpline.br_tocaka = 2*(pGLCanvas->BSpline.br_tocaka-1);
    pGLCanvas->BSpline.br_unesenih_tocaka = pGLCanvas->BSpline.br_tocaka;
    

	pGLCanvas->draw_curve = true;
    pGLCanvas->Draw();
    
    if(2*(pGLCanvas->BSpline.br_tocaka-1)+pGLCanvas->BSpline.degree+1 >= 4000)
        WxButtonUnifRef->Enable(false);  

}//end if
   
}

/*
 * WxEdit_br_tocakaUpdated
 */
void primjerFrm::WxEdit_br_tocakaUpdated(wxCommandEvent& event)
{
    WxButton_br_tocaka->Enable(!WxEdit_br_tocaka->IsEmpty());
}

/*
 * Mnuabout1032Click
 */
void primjerFrm::Mnuabout1032Click(wxCommandEvent& event)
{
	WxMessageDialog1->ShowModal();
}
